 ;=======================Fernsteuerung fr DTMF=================================
;MT8870 pin 11 auf porta, 0 des pic
;       pin 12 auf porta, 1
;       pin 13 auf porta, 2
;       pin 14 auf porta, 3
;strobe pin 15 auf porta, 4
;---------------------------
		list	p=16f627
		__config  		h'3f63'	;oscillator:EC (external clock in), watchdog timer:off, power-up timer:on, brown out:enabled, MCLRE: enabled,
				;low voltage program:disabled, data EE protect:off, code protect:off
		errorlevel	-302
		errorlevel	-306
;-----------------------------------
#define		strobe		porta, 4
#define		dtmf_da		porta, 6


;---------------sfr-----------------
status		equ	0x03	
eedata		equ	0x9a	;bank1	
eeadr		equ	0x9b	;bank1
eecon1		equ	0x9c	;bank1
eecon2		equ	0x9d	;bank1
intcon		equ	0x0b
pc			equ	0x02		;Programmzhler
porta		equ	0x05		;porta definieren
portb		equ	0x06		;portb definieren
trisa		equ	0x85	;bank1
trisb		equ	0x86	;bank1
cmcon		equ	0x1f
;---------------registerzuordnungen-----------------
temp		equ	0x20
ccount		equ	0x21
dcount		equ	0x22
temp_data 	equ 0x23
a_1			equ 0x24	
a_2			equ 0x25
dtmf_test	equ	0x26
;-----------------------eprom brennen beim programmieren
		org	0x2100
		de	b'00000000'	;alle 8 Bits vom Port B ausschalten

;---------------startadresse--------------------
		org	0x000		;Programmstart
		goto	start
		org	0x004
		goto	start

start		clrf	portb		;portb auf 0000 0000 setzen
			clrf	porta		;selbiges fr porta
			movlw	0x07		;Komparator Modul an porta ausschalten und
			movwf	cmcon		;porta als digitale ein/ausgnge definieren
			bsf		status, 5
			movlw 	0x00		;w Register mit binr 0000 0000 laden
			movwf	trisb		;0000 0000 in trisb laden,portb alle outputs 
			movlw	b'10111111'
			movwf	trisa		;porta alle inputs bis auf porta6: output
			bcf		status, 5

;----erst warten wir ein bischen (nur bei power up)
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
			call	pause200ms
			call	pause200ms

;----lese schaltzustand des portb aus dem eeprom aus, default b'00000000'-------------
; 
			bsf		status, 5
			movlw	0x00
			movwf	eeadr
			bsf		eecon1, 0
			movf	eedata, 0
			bcf		status, 5

			movwf	portb

;---------------freigabe mit dtmf 00-------------------------------------------
strob_start	movlw	0xfa
			movwf	a_1
			movlw	0xfa
			movwf	a_2
			btfss	strobe     	;dtmf da?
			goto	strob_start	;nein
			call	pause	;
			btfss	strobe	;dtmf da
			goto	strob_start		;nein
;---------------code zur freigabe der eingabe (dtmf 0,0)--------------  
eingang1	bsf		dtmf_da			;led fr dtmf erkennung einschalten
			movf	porta, 0		;daten von porta ins w register schreiben
			movwf	dtmf_test		; und in dtmftest schreiben
			bcf		dtmf_test, 7	;und die bits 7 bis 5 lschen
			bcf		dtmf_test, 6
			bcf		dtmf_test, 5	
			movf	dtmf_test, 0	;ergebnis in w

bittest		btfsc	strobe	;hat dtmf ton aufgehrt?
			goto 	bittest	;nein
			bcf		dtmf_da		;ja
subtraktion	sublw	b'00011010'	;subtrahiere 11010 von w register, bit5 mu 1 sein, da gesetzt
vergleiche	btfss	status, 2	;zeroflag testen auf 1
			goto	strob_start	;ton passt nicht
;
strob1		call	pause1		;time out timer : pause1 mal wert a_1 = time out timer in ms (hier 5s)
			decfsz	a_1, 1
			goto	xyz
			goto	strob_start
xyz			btfss	strobe
			goto	strob1
			call	pause
			btfss	strobe
			goto	strob1
			bsf		dtmf_da
			movlw	0xfa
			movwf	a_1
			movf	porta, 0	;daten von porta ins w register schreiben
			movwf	dtmf_test		; und in dtmftest schreiben
			bcf		dtmf_test, 7	;und die bits 7 bis 5 lschen
			bcf		dtmf_test, 6
			bcf		dtmf_test, 5	
			movf	dtmf_test, 0	;ergebnis in w

bittest1	btfsc	strobe	;bit4 in port a testen auf 0
			goto 	bittest1	;porta bit4 = 1 springe nach bittest,bei 0 nchste zeile
			bcf		dtmf_da
subtraktio	sublw	b'00011010'	;subtrahiere 11010 von w register, bit5 mu 1 sein
vergleich	btfss	status, 2	;zeroflag testen auf 1
			goto	strob_start		;wenn zeroflag = 0 springe, ansonsten nchste zeile
			
;--------------ab hier: dtmf ton zum schalten------------
strob		call	pause1
			decfsz	a_2, 1
			goto	xyz3	
			goto	strob_start	;time out timer hat zugeschlagen
								;berechnung : wert in a_2 mal lnge von pause1 bis er anspricht (hier 5 s)
xyz3		btfss	strobe		;liegt dtmf ton an?
			goto	strob		;nein
			call 	pause		;ja, schau ma  mal obs wirklich einer ist	
			btfss	strobe		;dtmf wirklich da?
			goto	strob 		;nein
			movlw	0xfa	;ja, reset time out timer
			movwf	a_2
			bsf		dtmf_da			;dtmf ton erkennung signalisieren
			movf	porta, 0	;dtmf da: Daten von porta ins w Register kopieren  
			movwf	dtmf_test		; und in dtmftest schreiben
			bcf		dtmf_test, 7	;und die bits 7 bis 5 lschen
			bcf		dtmf_test, 6
			bcf		dtmf_test, 5	
			movf	dtmf_test, 0	;ergebnis in w
			btfsc 	strobe		;warte bis dtmf ton aufhrt 
			goto 	$-1			; 
			bcf		dtmf_da		;dtmf ton erkennung signalisieren aus
			andlw	b'00001111'	;dtmf ton hat aufgehrt; strobe ausmaskieren (porta, 4) 
			
			movwf	temp		;und ins w-register retten fr tests welche dtmf tne es waren		
			sublw	b'00000001'	;wars dtmf1
			btfss	status, 2
			goto	nichtdtmf1	;nein
			bsf		portb, 0		;ja, portb, 0 einschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			goto	strob		;auf ein neues
			
nichtdtmf1	movf	temp, 0
			sublw	b'00000010'	;wars dtmf2	
			btfss	status, 2	
			goto	nichtdtmf2	;nein
			bcf		portb, 0		;ja, portb, 0 auschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			goto	strob		;auf ein neues


nichtdtmf2	movf	temp, 0		;und ins w-register retten fr tests welche dtmf tne es waren		
			sublw	b'00000011'	;wars dtmf3
			btfss	status, 2
			goto	nichtdtmf3	;nein
			bsf		portb, 1		;ja, portb, 1 einschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			goto	strob		;auf ein neues
			
nichtdtmf3	movf	temp, 0
			sublw	b'00000100'	;wars dtmf4	
			btfss	status, 2	
			goto	nichtdtmf4	;nein
			bcf		portb, 1		;ja, portb, 1 auschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			goto	strob		;auf ein neues


nichtdtmf4	movf	temp, 0		;und ins w-register retten fr tests welche dtmf tne es waren		
			sublw	b'00000101'	;wars dtmf5
			btfss	status, 2
			goto	nichtdtmf5	;nein
			bsf		portb, 2		;ja, portb, 2 einschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			goto	strob		;auf ein neues
			
nichtdtmf5	movf	temp, 0
			sublw	b'00000110'	;wars dtmf6	
			btfss	status, 2	
			goto	nichtdtmf6	;nein
			bcf		portb, 2		;ja, portb, 2 auschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			goto	strob		;auf ein neues


nichtdtmf6	movf	temp, 0		;und ins w-register retten fr tests welche dtmf tne es waren		
			sublw	b'00000111'	;wars dtmf7
			btfss	status, 2
			goto	nichtdtmf7	;nein
			bsf		portb, 3		;ja, portb, 3 einschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			goto	strob		;auf ein neues
			
nichtdtmf7	movf	temp, 0
			sublw	b'00001000'	;wars dtmf8	
			btfss	status, 2	
			goto	nichtdtmf8	;nein
			bcf		portb, 3		;ja, portb, 3 auschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			goto	strob		;auf ein neues


nichtdtmf8	movf	temp, 0		;und ins w-register retten fr tests welche dtmf tne es waren		
			sublw	b'00001001'	;wars dtmf9
			btfss	status, 2
			goto	nichtdtmf9	;nein
			bsf		portb, 4		;ja, portb, 4 einschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			goto	strob		;auf ein neues
			
nichtdtmf9	movf	temp, 0
			sublw	b'00001011'	;wars dtmf*	
			btfss	status, 2	
			goto	nichtdtmfstern	;nein
			bcf		portb, 4		;ja, portb, 4 auschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			goto	strob		;auf ein neues


nichtdtmfstern	movf	temp, 0		;und ins w-register retten fr tests welche dtmf tne es waren		
			sublw	b'00001010'	;wars dtmf0
			btfss	status, 2
			goto	nichtdtmf0	;nein
			bsf		portb, 5		;ja, portb, 5 einschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			goto	strob		;auf ein neues
			
nichtdtmf0	movf	temp, 0
			sublw	b'00001100'	;wars dtmf#	
			btfss	status, 2	
			goto	nichtdtmfkreuz	;nein
			bcf		portb, 5		;ja, portb, 5 auschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			goto	strob		;auf ein neues


nichtdtmfkreuz	movf	temp, 0		;und ins w-register retten fr tests welche dtmf tne es waren		
			sublw	b'00001101'	;wars dtmfa
			btfss	status, 2
			goto	nichtdtmfa	;nein
			bsf		portb, 6		;ja, portb, 6 einschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			goto	strob		;auf ein neues
			
nichtdtmfa	movf	temp, 0
			sublw	b'00001110'	;wars dtmfb	
			btfss	status, 2	
			goto	nichtdtmfb	;nein
			bcf		portb, 6		;ja, portb, 6 auschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			goto	strob		;auf ein neues


nichtdtmfb	movf	temp, 0		;und ins w-register retten fr tests welche dtmf tne es waren		
			sublw	b'00001111'	;wars dtmfc
			btfss	status, 2
			goto	nichtdtmfc	;nein
			bsf		portb, 7		;ja, portb, 7 einschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			goto	strob		;auf ein neues
			
nichtdtmfc	movf	temp, 0
			sublw	b'00000000'	;wars dtmfd	
			btfss	status, 2	
			goto	nichtdtmfd	;nein
			bcf		portb, 7		;ja, portb, 6 auschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			goto	strob		;auf ein neues

nichtdtmfd	goto	strob	;wir haben irgendwas gehrt, wissen aber nicht was
							;los von vorne ohne was zu ndern				
				

;---------------subroutinen-----------------
pause		movlw	0x39		;pause mit 11ms dauer
			movwf	ccount			;lnge der pause in zyklen: 3*wert(mcount)*wert(ncount) 
load1		movlw	0x3a		;1 zyklus: 1.1175S bei 3.579545MHZ Takt 
			movwf	dcount
dec1		decfsz	dcount, 1
			goto	dec1
			decfsz	ccount, 1
			goto	load1
			return			
;----------------
pause1		movlw	d'77'		;pause mit 20ms dauer
			movwf	ccount			;lnge der pause in zyklen: 3*wert(mcount)*wert(ncount) 
load4		movlw	d'78'		;1 zyklus: 
			movwf	dcount
dec4		decfsz	dcount, 1
			goto	dec4
			decfsz	ccount, 1
			goto	load4
			return			
;----------------
pause200ms	movlw	0xff		;pause mit 217ms dauer
			movwf	ccount
load2		movlw	0xff
			movwf	dcount
dec2		decfsz	dcount, 1
			goto	dec2
			decfsz	ccount, 1
			goto	load2
			return

;---------------eeprom beschreiben--------
eeprom		bsf		status, 5
			movlw	0x00
			movwf	eeadr
			bcf	status, 5	
			movf	portb, 0
			;movwf	temp_data
			;bcf	temp_data, 0	;unterste 4 bit vom port b lschen, haben nichts mit den relais zu tun
			;bcf	temp_data, 1
			;bcf	temp_data, 2
			;bcf	temp_data, 3
			;movf	temp_data, 0
			bsf	status, 5
			movwf	eedata
			
			bsf		eecon1, 2
			bcf		intcon, 7

			movlw	0x55
			movwf	eecon2
			movlw	0xaa
			movwf	eecon2
			bsf		eecon1, 1
abcd		btfsc	eecon1, 1
			goto	abcd
			bcf		eecon1, 2
			bcf		status, 5
			return



		end											 
